/*atmega8 1
2-16 .    PD4.
  .
:  .   .      
 .
.: +-      ds18b20   WinAVR
.: .  Wer-lehich
.E-mail:gam-raingers@mail.ru; wer-lehich@narod.ru
.:29.06.2008; 15.12.2011
*/

#include<avr/io.h>
#include<util/delay.h> 
#include<avr/interrupt.h>
#include <avr/sleep.h>



//     
#define BOOL	unsigned char            // 
#define false	0                        //  
#define true	1                        //  

//   LCD
#define LCD_E     PD0    //   /;
#define LCD_DATA  PD1    //   + RS -   /, ( 0 - , 1 -  );
#define LCD_CLK   PD2    //  
#define LCD_BCL   PD3    // 

static unsigned char base_y[2]={0x80,0xc0};  //   1  2 
unsigned char lcd_x, lcd_y, lcd_maxx;        //      
//unsigned char LCD_E, LCD_DATA, LCD_CLK, LCD_BCL; 

unsigned char i=0;
unsigned char i1=0;
unsigned char j=0;
unsigned char z=0;
unsigned char was_conflict=0; //   
unsigned char temperature=0;  // t   
int grand_temperature=0; // t  ,  (16 )
unsigned char des_temperature=0; // t   
unsigned int cifra=0; //    t
unsigned char znak=0;  // : 0 - "+";1 - "-"
unsigned char precense_ds18b20=0; //  
unsigned char ROM1[8]={0x28,0x89,0x71,0x02,0x02,0x00,0x00,0x8A};
unsigned char ROM2[8]={0x28,0x54,0x8F,0x02,0x02,0x00,0x00,0x00};
unsigned char i, CNT;
unsigned int send_data, cifra, cifra1, delta, adc_mid;
double ADCdata;


//==========================================================

void reset_ds1820(void);
void send_ds1820_command(unsigned char command);
void receive_ds1820(void);
unsigned char create_des(void);
void send_ROM_ds1820(unsigned char ROM);
void lcd_send_reg_2wire(unsigned char send_data, BOOL RS);
void lcd_putchar(unsigned char data);
void lcd_gotoxy(unsigned char x, unsigned char y);
void lcd_puts(char *str); 
void lcd_clear(void);
void adc(void);
void milivolt(unsigned int des, unsigned int delta1);
//===========================================================

//ISR(ADC_vect) //  -  
/*{
send_data=0;
 cifra=0; 
 cifra1=0;

// 10-
send_data=ADCW;
ADCdata=(send_data>>6);  //     


//    ADCdata/CNT
_delay_ms(100);
for (i=0; i<10; i++)                   //   10 
  {

    if ((send_data & 0x8000) == 0x8000) //  7-  == 1 (..    )
    {lcd_send_reg_2wire(0x31,true);     //  1   
      _delay_loop_1(1);
	}
	else  
    {                                // 
    lcd_send_reg_2wire(0x30,true);     //  0     
    _delay_loop_1(1);                 //    
	}


	_delay_ms(1);
                                            //   CLK
    send_data = send_data << 1;            //    1  
  }

_delay_ms(100);

//      
lcd_send_reg_2wire(' ',true);
lcd_send_reg_2wire(' ',true);
adc_mid=ADCdata*2;//CNT;
		milivolt(adc_mid, delta);
_delay_ms(100);
_delay_ms(100);

//   
}*/




void milivolt(unsigned int des, unsigned int delta1)
{unsigned int cifra1;
		cifra=0;
		cifra1=0;
		cifra1=(des-delta1);        //   delta
		cifra=cifra1/100;
		lcd_send_reg_2wire(cifra+0x30,true);
		cifra=cifra1%100;
		cifra1=cifra/10;
		lcd_send_reg_2wire(cifra1+0x30,true);
		cifra1=cifra%10;

		lcd_send_reg_2wire(cifra1+0x30,true);

}




void adc(void)
{
lcd_gotoxy(0,1);
ADCdata = 0;  
//    "0"   (10-)
//delta=0;
delta=0x96;
//   .  
ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<ADLAR);//0b11100000; 
//      32,    
//   
ADCSR = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS0);//0b10101101; 
ADCSR = ADCSR|0x40;
cli(); //   
_delay_ms(100);
_delay_ms(100);
_delay_ms(100);
_delay_ms(100);
sei();

//***************************************************************

send_data=0;
 cifra=0; 
 cifra1=0;

// 10-
send_data=ADCW;
ADCdata=(send_data>>6);  //     


//    ADCdata/CNT
//_delay_ms(100);
/*
//***************************************************************************
for (i=0; i<10; i++)                   //   10 
  {

    if ((send_data & 0x8000) == 0x8000) //  7-  == 1 (..    )
    {lcd_send_reg_2wire(0x31,true);     //  1   
      _delay_loop_1(1);
	}
	else  
    {                                // 
    lcd_send_reg_2wire(0x30,true);     //  0     
    _delay_loop_1(1);                 //    
	}


	_delay_ms(1);
                                            //   CLK
    send_data = send_data << 1;            //    1  
  }
  //**************************************************************************
  */

//***********************************************************_delay_ms(100);
// 
lcd_send_reg_2wire('G',true);
lcd_send_reg_2wire('n',true);
lcd_send_reg_2wire('=',true);

//      

adc_mid=ADCdata*2;//CNT;
		milivolt(adc_mid, delta);
lcd_send_reg_2wire('T',true);
lcd_send_reg_2wire('/',true);
lcd_send_reg_2wire('h',true);		
_delay_ms(100);
_delay_ms(100);

//   

//ADCSR = ADCSR|0x40;

//***************************************************************
/*MCUCR=0b10010000;          //  -  
      set_sleep_mode(_BV(SM0));
      sleep_mode();
_delay_ms(100);
//while(1); //      
{
};*/
}


//    DS18B20
//***********************************************************
//  DS1820
void reset_ds1820(void)
{
cli();
DDRD|=_BV(6);        //     
_delay_loop_2(120); // 0  .  480 
DDRD&=~_BV(6);       //    
_delay_loop_2(18);  //   70 
 if(PIND & (1<<PIND6))  // 1 -   
  {
  precense_ds18b20=0;
  }   
  else
  {
  precense_ds18b20=1;   //   
  } 
  
_delay_loop_2(103); //410 
sei();
}
//  

void send_ds1820_command(unsigned char command)
{
cli();
unsigned char data=command;
for(i=0;i<8;i++)
{
data=data<<7;        //  i  
command=command>>1;  //  
if(data==0x80)       // .1
{
DDRD|=_BV(6);        
_delay_loop_2(2);   //   6 
DDRD&=~_BV(6);       
_delay_loop_2(16);   //   64   
}
else                 // .0
{
DDRD|=_BV(6);        
_delay_loop_2(15);  //60 
DDRD&=~_BV(6);        
 _delay_loop_2(3);  //10 
}
data=command;        //   
};
sei();
}

//    DS18B20
void receive_ds1820(void)
{
cli();
znak=0;
for(i=0;i<16;i++)     // 2     
{
DDRD|=_BV(6);        
_delay_loop_2(2);  //   6   
DDRD&=~_BV(6);       
_delay_loop_1(3);  //   9 
 if (PIND & (1<<PIND6)) //  
 {
 grand_temperature|=_BV(i);      // . 1 
   if(i==12)
   {
   znak=1;
   } 
 }
 else
 {
 grand_temperature&=~_BV(i);    // . 0     
 }
 _delay_loop_2(138);
} 
// 
   if(znak==1)  // 
   {
   grand_temperature=65536-grand_temperature;
   }

 des_temperature=grand_temperature&0b00001111;
 temperature=(grand_temperature>>4);
 sei();
}

//    t
unsigned char create_des(void)
{
 unsigned char des_var=0;
 if(des_temperature==0){des_var=0;}
 else if(des_temperature==1 || des_temperature==2){des_var=1;}
 else if(des_temperature==3){des_var=2;}
 else if(des_temperature==4 || des_temperature==5){des_var=3;}
 else if(des_temperature==6 || des_temperature==7){des_var=4;}
 else if(des_temperature==8){des_var=5;}
 else if(des_temperature==9 || des_temperature==10){des_var=6;}
 else if(des_temperature==11){des_var=7;}
 else if(des_temperature==12 || des_temperature==13){des_var=8;}
 else if(des_temperature==14 || des_temperature==15){des_var=9;}
 return des_var;
}

void send_ROM_ds1820(unsigned char selector)
{
  for(j=0;j<8;j++)
  { 
		if(selector==0)
		{
		send_ds1820_command(ROM1[j]);
		}
		else 
		{
		send_ds1820_command(ROM2[j]);
		}
  };
}
//***********************************************************
//***********************************************************
//***********************************************************
//***********************************************************
//***********************************************************
//    3- 
//***********************************************************

void lcd_init(unsigned char lcd_columns)
{
lcd_maxx=lcd_columns;
PORTD &=~_BV(LCD_E);           //LCD_E = 0;  
PORTD &=~_BV(LCD_DATA);        //LCD_DATA = 0;
PORTD &=~_BV(LCD_CLK);        //LCD_CLK  = 0;
_delay_ms(200);                //    , 400
_delay_ms(15);
lcd_send_reg_2wire(0x30,false);   //
_delay_ms(5);
lcd_send_reg_2wire(0x30,false);   //
_delay_ms(5);
lcd_send_reg_2wire(0x30,false);   //
_delay_ms(5);						// 200
lcd_send_reg_2wire(0x38,false);   // 8  , 2 ,   57.
_delay_ms(5);
lcd_send_reg_2wire(0x08,false);   //  ,  ,  .                    
_delay_ms(5);
lcd_send_reg_2wire(0x01,false);   //  
_delay_ms(5);
lcd_send_reg_2wire(0x06,false);   // Increment cursor to the right when writing, don't shift screen
_delay_ms(5);
lcd_send_reg_2wire(0x0C,false);   //  ,  ,  .                    
_delay_ms(5);
}
void lcd_gotoxy(unsigned char x, unsigned char y)
{
lcd_send_reg_2wire(base_y[y]+x, false);
lcd_x=x;
lcd_y=y;
_delay_ms(1);
}

//   LCD
void lcd_clear(void)
{
lcd_send_reg_2wire(2,false);   // cursor home
_delay_ms(1);
lcd_send_reg_2wire(0xc,false); // cursor off
_delay_ms(1);
lcd_send_reg_2wire(1,false);   // clear
_delay_ms(1);
lcd_x=lcd_y=0;
}


void lcd_putchar(unsigned char data)
{
if (lcd_x>lcd_maxx)
   {
      ++lcd_y;
      lcd_gotoxy(0,lcd_y);
   };
lcd_gotoxy(lcd_x,lcd_y);
lcd_send_reg_2wire(data, true);
++lcd_x;
}

//     SRAM  LCD
void lcd_puts(char *str)
{
while((*str)!=0) lcd_putchar(*str++);                         //  
}


//     FLASH  LCD
void lcd_putsf(char *str)//void lcd_putsf(char flash *str)
{
while((*str)!=0) lcd_putchar(*str++);                         //  
}

void lcd_send_reg_2wire(unsigned char send_data, BOOL RS)
{
unsigned int i;

if(RS==false)             //LCD_DATA = RS;
{
PORTD &=~_BV(LCD_DATA);
}
else
{
PORTD|= _BV(LCD_DATA);
}                                                //  
PORTD|= _BV(LCD_E);    //LCD_E = 1;                      //   
for (i=0; i<8; i++)                                           //   8 
  {
    if ((send_data & 0x80) == 0x80)                           //  7-  == 1 (..    )
      PORTD|= _BV(LCD_DATA);//LCD_DATA = 1;                                           //  1   
    else                                                      // 
      PORTD &=~_BV(LCD_DATA);//LCD_DATA = 0;                                           //  0     
    _delay_loop_1(1);//_delay_ms(1);//#asm("nop");                                              //    
    PORTD|= _BV(LCD_CLK);//LCD_CLK = 1;                                              //   CLK
    _delay_loop_1(1);//#asm("nop");                                              //   CLK
    PORTD &=~_BV(LCD_CLK);//LCD_CLK = 0;                                              //   CLK
    send_data = send_data << 1;                               //    1  
  }

if(RS==false)             //LCD_DATA = RS;
{
PORTD &=~_BV(LCD_DATA);
}
else
{
PORTD|= _BV(LCD_DATA);
}                                          
_delay_us(255)  ;
PORTD &=~_BV(LCD_E);//LCD_E = 0;  //   
PORTD &=~_BV(LCD_DATA);//LCD_DATA = 0;                                               
}
//***********************************************************
//***********************************************************

int main(void)
{
DDRB=0xFF;
DDRD=0xFF;           //   . PD3- .
PORTD|= _BV(7);          // PD7 -    DS18B20. PD4-
PORTD|= _BV(LCD_BCL);   //  LCD 
_delay_loop_2(65000);   //,  
PORTD &=~_BV(LCD_BCL);  // 
sei();
lcd_init(16);
lcd_gotoxy(0,0);
lcd_putsf("TnToADC0");//,  LCD 
lcd_clear();
PORTD|= _BV(LCD_BCL);
while(1)		//  
{
//    
//******************************************
	for(z=0;z<2;z++)
	{
		reset_ds1820();
		send_ds1820_command(0x55);  // ROM
		send_ROM_ds1820(z);
		send_ds1820_command(0x44);  //  t
/*
												for(j=0;j<12;j++)          //  
												{
												_delay_loop_2(250);
												};
*/
					 reset_ds1820();
					 send_ds1820_command(0x55);  // ROM
					 send_ROM_ds1820(z);
					 send_ds1820_command(0xBE);
					 receive_ds1820();		
							
							if(z<1)		
							{
							lcd_send_reg_2wire('t', true);  
							lcd_send_reg_2wire('n', true);                
							}
							else
							{
							lcd_gotoxy(8,0);
							lcd_send_reg_2wire('t', true);
							lcd_send_reg_2wire('o', true);               
							}
					lcd_send_reg_2wire('=', true);
						if(znak==1) //  
						{
						lcd_send_reg_2wire('-', true);
						cifra=temperature/10;                          
						lcd_send_reg_2wire(cifra+0x30, true);  
						cifra=temperature%10;
						lcd_send_reg_2wire(cifra+0x30, true);
						}

						else
						{
								if(temperature>=100) //  
								{
								lcd_send_reg_2wire(0x31, true);
								temperature=temperature-100;
								cifra=temperature/10;                          //       100 .
								lcd_send_reg_2wire(cifra+0x30, true);
								cifra=temperature%10;
								lcd_send_reg_2wire(cifra+0x30, true);
								}
								else
								{
								lcd_send_reg_2wire('+', true);
								cifra=temperature/10;  
								lcd_send_reg_2wire(cifra+0x30, true);
								cifra=temperature%10;
								lcd_send_reg_2wire(cifra+0x30, true);
								}
						}
					 
					lcd_send_reg_2wire(',', true);
					cifra=create_des();
					lcd_send_reg_2wire(cifra+0x30, true);
					//      
							//if(z==0)
							//{
							//for(i=0;i<32;i++)
							//{
							//lcd_send_reg_2wire(' ', true);
							//};							
							//}

//;
lcd_send_reg_2wire(0x80, false);          //send_command(0x80);
};


adc();
lcd_clear();
};
//dream:    10  
/*
cli();
DDRB=0x00;
DDRD=0x00;           
PORTD=0x00;
PORTB=0x00;
      set_sleep_mode(_BV(SM0));
      sleep_mode();
	  */
}





